<?php

declare(strict_types=1);

namespace Seka\Terminy\Listeners\Udalost;

use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Illuminate\Support\Facades\Notification;
use Seka\Terminy\Dtos\Factory\UdalostDTOFactory;
use Seka\Terminy\Events\Udalost\UdalostBolaAktualizovana;
use Seka\Terminy\Notifications\Udalost\AktualizovanaUdalostNotifikaciaDB;
use Seka\Terminy\Notifications\Udalost\AktualizovanaUdalostNotifikaciaMail;

/**
 * Class OdoslatNotifikacieOAktualizovanejUdalosti
 *
 * @package Seka\Terminy\Listeners\Udalost
 */
final class OdoslatNotifikacieOAktualizovanejUdalosti
{
    /**
     * @param \Seka\Terminy\Events\Udalost\UdalostBolaAktualizovana $event
     */
    public function handle(UdalostBolaAktualizovana $event)
    {
        $udalost = UdalostDTOFactory::make($event->udalost);
        $udalostPovodna = UdalostDTOFactory::make($event->udalostPovodna);

        Notification::send(
            Pouzivatel::query()->aktivny()->get(),
            new AktualizovanaUdalostNotifikaciaDB($udalost)
        );

        Notification::send(
            Pracovisko::query()->get(),
            new AktualizovanaUdalostNotifikaciaMail($udalost, $udalostPovodna)
        );
    }
}
